## lomiri-sync-monitor 0.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(lomiri-sync-monitor VERSION 0.6.0 LANGUAGES CXX)

include(FindPkgConfig)
include(FindGettext)
include(GNUInstallDirs)

find_package(Qt5Core REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Organizer REQUIRED)
add_definitions(-DQT_NO_KEYWORDS)

find_package(GMock REQUIRED)

pkg_check_modules(ACCOUNTS REQUIRED accounts-qt5>=1.10)
pkg_check_modules(URLDISPATCHER REQUIRED lomiri-url-dispatcher)
pkg_check_modules(LIBNOTIFY libnotify)
pkg_check_modules(LIBSIGNON REQUIRED libsignon-qt5)
pkg_check_modules(SYSTEMD REQUIRED systemd)
pkg_check_modules(LOMIRI_CONNECTIVITY REQUIRED lomiri-connectivity-qt1)
pkg_check_modules(ONLINE_ACCOUNTS_PLUGINS REQUIRED LomiriOnlineAccountsPlugin)

pkg_get_variable(PLUGIN_QML_DIR LomiriOnlineAccountsPlugin plugin_qml_dir)
pkg_get_variable(SERVICE_FILE_BASE_DIR accounts-qt5 servicefilesdir)
set(SERVICE_FILE_DIR ${SERVICE_FILE_BASE_DIR}/lomiri)
pkg_get_variable(PROVIDER_FILE_BASE_DIR accounts-qt5 providerfilesdir)
set(PROVIDER_FILE_DIR ${PROVIDER_FILE_BASE_DIR}/lomiri)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

set(DESKTOP_FILE accounts/desktop/lomiri-sync-monitor-calendar.desktop)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
               IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}"
                  -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

enable_testing()
add_subdirectory(3rd_party)
add_subdirectory(src)
add_subdirectory(authenticator)
add_subdirectory(accounts)
add_subdirectory(templates)
add_subdirectory(tests)
add_subdirectory(po)
add_subdirectory(Lomiri)
add_subdirectory(systemd)

configure_file(config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)

=== 3rd_party/CMakeLists.txt ===
add_subdirectory(syncevolution-qt)

=== accounts/CMakeLists.txt ===
# this assumes ITS files are located in ${CMAKE_SOURCE_DIR}/its
function(gettext_merge_xml_translations source_files)
    foreach(source_file ${source_files})
        add_custom_target("${source_file}" ALL
                          COMMENT "Merging translations into ${source_file}"
                          COMMAND ${CMAKE_COMMAND} -E env "GETTEXTDATADIRS=${CMAKE_SOURCE_DIR}"
                                  ${GETTEXT_MSGFMT_EXECUTABLE}
                                  --xml
                                  --template=${CMAKE_CURRENT_SOURCE_DIR}/${source_file}.in
                                  -d ${CMAKE_SOURCE_DIR}/po
                                  -o ${source_file}
                          )
    endforeach()
endfunction()

add_subdirectory(plugin)
add_subdirectory(services)
add_subdirectory(desktop)

=== authenticator/CMakeLists.txt ===
project(lomiri-sync-monitor-helper)

set(LOMIRI_SYNC_MONITOR_HELPER_BIN lomiri-sync-monitor-helper)

QT5_ADD_RESOURCES(LOMIRI_SYNC_MONITOR_HELPER_RC
    lomiri-sync-monitor-helper.qrc
)

include_directories(
    ${CMAKE_BINARY_DIR}
)

add_executable(${LOMIRI_SYNC_MONITOR_HELPER_BIN}
    main.cpp
    ${LOMIRI_SYNC_MONITOR_HELPER_RC}
)

qt5_use_modules(${LOMIRI_SYNC_MONITOR_HELPER_BIN} Core DBus Gui Quick)

set(LOMIRI_SYNC_MONITOR_HELPER_QMLS
    main.qml
)

set(LOMIRI_SYNC_MONITOR_HELPER_INSTALL_PATH
    ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/lomiri-sync-monitor/
)

install(FILES "lomirisyncmonitorhelper.url-dispatcher"
    DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-url-dispatcher/urls
)

configure_file(lomirisyncmonitorhelper.desktop.in lomirisyncmonitorhelper.desktop)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/lomirisyncmonitorhelper.desktop"
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
)

install(TARGETS ${LOMIRI_SYNC_MONITOR_HELPER_BIN}
        RUNTIME DESTINATION ${LOMIRI_SYNC_MONITOR_HELPER_INSTALL_PATH})

# make the files visible on qtcreator
add_custom_target(lomiri_sync_monitor_helper_QMlFiles ALL SOURCES ${LOMIRI_SYNC_MONITOR_HELPER_QMLS})

=== po/CMakeLists.txt ===
project(lomiri-sync-monitor-translations)

find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

set(DOMAIN lomiri-sync-monitor)
set(POT_FILE ${DOMAIN}.pot)

file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS LINGUAS
     REGEX "^[^#].*")
string(REGEX MATCHALL "[^ \t]+" LANGS "${LINGUAS}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in
  ${CMAKE_CURRENT_BINARY_DIR}/POTFILES COPYONLY
)

add_custom_target(${POT_FILE} ALL
  COMMENT "Generating translation template"
  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
          --from-code=UTF-8
          --language=Desktop
          --package-name='${PROJECT_NAME}'
          --copyright-holder='Canonical Ltd.'
          -D ${CMAKE_SOURCE_DIR}
          ${DESKTOP_FILE}.in
  COMMAND ${CMAKE_COMMAND} -E env "GETTEXTDATADIRS=${CMAKE_SOURCE_DIR}"
          ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
          -D ${CMAKE_SOURCE_DIR}
          -D ${CMAKE_CURRENT_SOURCE_DIR}
          -D ${CMAKE_CURRENT_BINARY_DIR}
          --keyword=_ --keyword=N_
          --keyword=tr --keyword=tr:1,2
          --keyword=dtr:2 --keyword=dtr:2,3
          --package-name='${DOMAIN}'
          --copyright-holder='Canonical Ltd.'
          --from-code=utf-8
          --files-from=${CMAKE_CURRENT_BINARY_DIR}/POTFILES)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${POT_FILE}
               ${CMAKE_CURRENT_BINARY_DIR}/${POT_FILE}
               COPYONLY)
foreach(LANG ${LANGS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${LANG}.po
                   ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.po
                   COPYONLY)
endforeach(LANG)
gettext_process_pot_file(${POT_FILE} ALL
                         INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
                         LANGUAGES ${LANGS})

=== src/CMakeLists.txt ===
project(synq-src)
add_definitions(-std=c++11)

set(SYNQ_BIN lomiri-sync-monitor)
set(SYNQ_LIB synq-lib)

set(SYNQ_LIB_SRC
    eds-helper.h
    eds-helper.cpp
    notify-message.h
    notify-message.cpp
    repowerd-proxy.h
    repowerd-proxy.cpp
    provider-template.h
    provider-template.cpp
    sync-account.h
    sync-account.cpp
    sync-auth.h
    sync-auth.cpp
    sync-configure.h
    sync-configure.cpp
    sync-daemon.h
    sync-daemon.cpp
    sync-dbus.h
    sync-dbus.cpp
    sync-i18n.h
    sync-queue.h
    sync-queue.cpp
    sync-network.h
    sync-network.cpp
    syncevolution-server-proxy.h
    syncevolution-server-proxy.cpp
    syncevolution-session-proxy.h
    syncevolution-session-proxy.cpp
)

add_library(${SYNQ_LIB} STATIC
    ${SYNQ_LIB_SRC}
)

target_link_libraries(${SYNQ_LIB}
    ${ACCOUNTS_LIBRARIES}
    ${LIBNOTIFY_LIBRARIES}
    ${LIBSIGNON_LIBRARIES}
    ${URLDISPATCHER_LIBRARIES}
    ${LOMIRI_CONNECTIVITY_LIBRARIES}
    syncevolution-qt
)

qt5_use_modules(${SYNQ_LIB} Core DBus Organizer Contacts Network)

set(SYNQ_BIN_SRC
    main.cpp
)

add_executable(${SYNQ_BIN}
    ${SYNQ_BIN_SRC}
)

target_link_libraries(${SYNQ_BIN}
    ${SYNQ_LIB}
)

qt5_use_modules(${SYNQ_BIN} Core )

include_directories(
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
    ${ACCOUNTS_INCLUDE_DIRS}
    ${LIBSIGNON_INCLUDE_DIRS}
    ${LIBNOTIFY_INCLUDE_DIRS}
    ${URLDISPATCHER_INCLUDE_DIRS}
    ${LOMIRI_CONNECTIVITY_INCLUDE_DIRS}
    ${syncevolution-qt_SOURCE_DIR}
)

install(TARGETS ${SYNQ_BIN}
        RUNTIME DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/lomiri-sync-monitor/)

set(DBUS_SERVICE_FILE com.lomiri.SyncMonitor.service)
configure_file(dbus/${DBUS_SERVICE_FILE}.in
               ${CMAKE_CURRENT_BINARY_DIR}/dbus/${DBUS_SERVICE_FILE}
               @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dbus/${DBUS_SERVICE_FILE}
        DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/dbus-1/services/)

=== systemd/CMakeLists.txt ===
pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)

configure_file(lomiri-sync-monitor.service.in ${CMAKE_CURRENT_BINARY_DIR}/lomiri-sync-monitor.service)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lomiri-sync-monitor.service
        DESTINATION ${SYSTEMD_USER_UNIT_DIR}
)

=== templates/CMakeLists.txt ===
set(TEMPLATE_FILES
     generic-caldav.conf
     google.conf
     yahoo.conf
     owncloud.conf
     nextcloud.conf
)

install(FILES ${TEMPLATE_FILES}
    DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/lomiri-sync-monitor/templates
)

=== Lomiri/SyncMonitor/CMakeLists.txt ===
set(SYNC_MONITOR_QML_SRC
    plugin.h
    plugin.cpp
    syncmonitor-qml.h
    syncmonitor-qml.cpp
)

set(SYNC_MONITOR_QML_FILES
    qmldir
)

add_library(syncmonitor-qml SHARED ${SYNC_MONITOR_QML_SRC})
qt5_use_modules(syncmonitor-qml Core Qml DBus)

set(QT_INSTALL_QML "${CMAKE_INSTALL_LIBDIR}/qt5/qml")

set(SYNC_MONITOR_QML_INSTALL_DIR ${QT_INSTALL_QML}/Lomiri/SyncMonitor)
install(TARGETS syncmonitor-qml DESTINATION ${SYNC_MONITOR_QML_INSTALL_DIR})
install(FILES ${SYNC_MONITOR_QML_FILES} DESTINATION ${SYNC_MONITOR_QML_INSTALL_DIR})

# make the files visible on qtcreator
add_custom_target(syncmonitor_QmlFiles ALL SOURCES ${SYNC_MONITOR_QML_FILES})

=== accounts/desktop/CMakeLists.txt ===
get_filename_component(DESKTOP_FILE_NAME ${DESKTOP_FILE} NAME)

add_custom_target(${DESKTOP_FILE_NAME} ALL
  COMMENT "Merging translations into ${DESKTOP_FILE_NAME}"
  COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
          --desktop
          --template=${CMAKE_CURRENT_SOURCE_DIR}/${DESKTOP_FILE_NAME}.in
          -o ${DESKTOP_FILE_NAME}
          -d ${CMAKE_SOURCE_DIR}/po
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE_NAME}
        DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/applications
)

=== accounts/services/CMakeLists.txt ===
set(SERVICE_FILES
    generic-caldav.service
    google-caldav.service
    owncloud-caldav.service
    nextcloud-caldav.service
)

gettext_merge_xml_translations("${SERVICE_FILES}")

foreach(SERVICE_FILE ${SERVICE_FILES})
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${SERVICE_FILE}
        DESTINATION ${SERVICE_FILE_DIR}
    )
endforeach()

=== tests/unittest/CMakeLists.txt ===
macro(declare_test TESTNAME)
    add_executable(${TESTNAME}
                   ${ARGN})
    qt5_use_modules(${TESTNAME} Core Test Contacts)

    target_link_libraries(${TESTNAME}
                          ${ACCOUNTS_LIBRARIES}
                          ${LOMIRI_CONNECTIVITY_LIBRARIES}
                          synq-lib
                          ${GMOCK_LIBRARIES}
    )

    add_test(${TESTNAME} ${TESTNAME})
endmacro()

include_directories(
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
    ${ACCOUNTS_INCLUDE_DIRS}
    ${syncevolution-qt_SOURCE_DIR}
    ${GMOCK_INCLUDE_DIRS}
)

declare_test(sync-queue-test
             sync-queue-test.cpp
             sync-account-mock.h
)

declare_test(eds-helper-test
             eds-helper-test.cpp
             eds-helper-mock.h
)

declare_test(syncevolution-output-parser
             syncevolution-output-parser.cpp
             ${CMAKE_SOURCE_DIR}/3rd_party/syncevolution-qt/dbustypes.cpp)

=== debian/changelog ===
lomiri-sync-monitor (0.6.0-4) unstable; urgency=medium

  * debian/control:
    + Update B-D: on libsignon-qt5-dev and let it depend on version
      8.61+git20231015.c8ad982-7~. (Closes: #1086780).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 11 Dec 2024 23:16:25 +0100

lomiri-sync-monitor (0.6.0-3) unstable; urgency=medium

  * Re-upload as is source-only.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 31 Aug 2024 07:47:14 +0200

lomiri-sync-monitor (0.6.0-2) unstable; urgency=medium

  * debian/control:
    + Adjust LONG_DESCRIPTIONs. Lomiri's sync-monitor is only responsible for
      calendar syncs, not address book syncs.
    + Drop from D (lomiri-sync-monitor): lomiri-address-book-service.
  * debian/patches:
    + Add 1004_drop-abook-service-dependency.patch. Become independent from
      lomiri-address-book-service (which won't be packaged for Debian as
      deprecated upstream).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 19 Aug 2024 12:09:03 +0200

lomiri-sync-monitor (0.6.0-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1078817).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 17 Aug 2024 08:06:03 +0200

=== debian/control ===
Source: lomiri-sync-monitor
Section: misc
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras,
               debhelper-compat (= 13),
               googletest | google-mock,
               libgmock-dev,
               libaccounts-qt5-dev,
               libnotify-dev,
               liblomiri-url-dispatcher-dev,
               libsignon-qt5-dev (>= 8.61+git20231015.c8ad982-7~),
               pkgconf,
               qtbase5-dev,
               qtdeclarative5-dev,
               qml-module-lomiri-components,
               qml-module-lomiri-onlineaccounts,
               qtpim5-dev (>= 5.0~git20171109~0bd985b),
               liblomiri-connectivity-qt1-dev (>= 1.0.2-7~),
               liblomiri-online-accounts-plugin-dev,
               systemd-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-sync-monitor
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-sync-monitor.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-sync-monitor

Package: lomiri-sync-monitor
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         syncevolution-dbus (>= 1.4),
         lomiri-sync-monitor-helper (>= ${binary:Version}),
         libqt5contact5-plugin-sqlite,
         qtorganizer5-eds,
Suggests: lomiri-account-plugin-google,
          syncevolution-provider-loa (>= 1.4),
Description: Lomiri online account sync monitor plugin
 Lomiri's sync-monitor manages data synchronization of calendars
 .
 With this service you can keep track of Lomiri online accounts and sync
 with the cloud.

Package: lomiri-sync-monitor-loa
Architecture: all
Depends: ${misc:Depends},
         lomiri-sync-monitor (>= ${binary:Version}),
         qml-module-lomiri-components,
         qml-module-lomiri-onlineaccounts-plugin,
         qml-module-sso-onlineaccounts,
Description: Lomiri online account sync monitor plugin - service files
 Lomiri's sync-monitor manages data synchronization of calendars
 .
 This package contains the Lomiri online accounts service files.

Package: qml-module-lomiri-syncmonitor
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri online account sync monitor plugin - QML bindings
 Lomiri's sync-monitor manages data synchronization of calendars
 .
 This package contains the QML plugin providing the features from the sync
 monitor to applications.

Package: lomiri-sync-monitor-helper
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-lomiri-components,
         qml-module-lomiri-onlineaccounts,
Description: Lomiri online account sync monitor plugin - Helper and service files
 Lomiri's sync-monitor manages data synchronization of calendars
 .
 This package contains the Lomiri online accounts service files and helper to
 re-authenticate online accounts.
